
signature COMPILE = sig
val compile : Fiacre.Fiacre -> unit
end;

structure Compile : COMPILE = struct

(* for debug, prints compilation passes
fun compile p = 
    (printVerbose "::Compilation\n";
     let fun F f m p =
	     if !VERBOSE then
		 (print m; print "\n";
		  let val res = f p
		  in print "  ::Done\n";
		     res
		  end)
	     else
		 f p
	 val result =
	     (F Emit.emit "  ::Emit" o 
	      F Optimize.optimize "  ::Optimize" o
	      F PostCompose.postcompose "  ::PostCompose" o 
	      F Compose.compose "  ::Compose" o 
	      F ToTTS.toTTS "  ::ToTTS")
		 p
     in printVerbose "::Done\n";
	result
     end);
 *)

fun compile p = 
    (printVerbose "::Compilation\n";
     let val result =
	     (Emit.emit o 
	      Optimize.optimize o
	      PostCompose.postcompose o 
	      Compose.compose o 
	      ToTTS.toTTS)
		 p
     in printVerbose "::Done\n";
	result
     end);

end;

	  
